diff --git a/oflog/include/dcmtk/oflog/thread/impl/syncpthr.h b/oflog/include/dcmtk/oflog/thread/impl/syncpthr.h
new file mode 100644
index 0000000..7849cfb
--- /dev/null
+++ b/oflog/include/dcmtk/oflog/thread/impl/syncpthr.h
@@ -0,0 +1,515 @@
+// -*- C++ -*-
+//  Copyright (C) 2009-2010, Vaclav Haisman. All rights reserved.
+//
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+//! @file
+//! This file contains implementations of synchronization
+//! primitives using the POSIX threads. It does not contain any
+//! include guards because it is only a fragment to be included by
+//! syncprims.h.
+
+#include "dcmtk/oflog/thread/threads.h"
+#include "dcmtk/ofstd/ofstream.h"
+#include <limits>
+#include <algorithm>
+
+
+namespace dcmtk {
+namespace log4cplus { namespace thread { namespace impl {
+
+
+struct PthreadMutexAttr
+{
+    PthreadMutexAttr ()
+        : attr()
+    {
+        int ret = pthread_mutexattr_init (&attr);
+        if (ret != 0)
+            DCMTK_LOG4CPLUS_THROW_RTE ("PthreadMutexAttr::PthreadMutexAttr");
+    }
+
+
+    ~PthreadMutexAttr ()
+    {
+        try
+        {
+            int ret = pthread_mutexattr_destroy (&attr);
+            if (ret != 0)
+                DCMTK_LOG4CPLUS_THROW_RTE ("PthreadMutexAttr::~PthreadMutexAttr");
+        }
+        catch (...)
+        { }
+    }
+
+
+    void
+    set_type (log4cplus::thread::Mutex::Type t)
+    {
+        int mutex_type;
+        switch (t)
+        {
+        case log4cplus::thread::Mutex::RECURSIVE:
+            mutex_type = PTHREAD_MUTEX_RECURSIVE;
+            break;
+
+        default:
+            mutex_type = PTHREAD_MUTEX_DEFAULT;
+        }
+
+        int ret = pthread_mutexattr_settype (&attr, mutex_type);
+        if (ret != 0)
+            DCMTK_LOG4CPLUS_THROW_RTE ("PthreadMutexAttr::set_type");
+    }
+
+
+    pthread_mutexattr_t attr;
+};
+
+
+//
+//
+//
+
+inline
+Mutex::Mutex (log4cplus::thread::Mutex::Type t)
+    : mtx()
+{
+    PthreadMutexAttr attr;
+    attr.set_type (t);
+
+    int ret = pthread_mutex_init (&mtx, &attr.attr);
+    if (ret != 0)
+        DCMTK_LOG4CPLUS_THROW_RTE ("Mutex::Mutex");
+}
+
+
+inline
+Mutex::~Mutex ()
+{
+    try
+    {
+        int ret = pthread_mutex_destroy (&mtx);
+        if (ret != 0)
+            DCMTK_LOG4CPLUS_THROW_RTE ("Mutex::~Mutex");
+    }
+    catch (...)
+    { }
+}
+
+
+inline
+void
+Mutex::lock () const
+{
+    int ret = pthread_mutex_lock (&mtx);
+    if (ret != 0)
+        DCMTK_LOG4CPLUS_THROW_RTE ("Mutex::lock");
+}
+
+
+inline
+void
+Mutex::unlock () const
+{
+    int ret = pthread_mutex_unlock (&mtx);
+    if (ret != 0)
+        DCMTK_LOG4CPLUS_THROW_RTE ("Mutex::unlock");
+}
+
+
+//
+//
+//
+
+inline
+Semaphore::Semaphore (unsigned max, unsigned initial)
+    : sem()
+{
+    unsigned const sem_value_max =
+#if defined (SEM_VALUE_MAX)
+        SEM_VALUE_MAX
+#else
+        (STD_NAMESPACE numeric_limits<int>::max) ()
+#endif
+        ;
+
+    unsigned const limited_max = (STD_NAMESPACE min) (max, sem_value_max);
+    unsigned const limited_initial = (STD_NAMESPACE min) (initial, limited_max);
+    int ret = 0;
+
+#if defined (DCMTK_LOG4CPLUS_USE_NAMED_POSIX_SEMAPHORE)
+    OFOStringStream oss;
+    char size_check[2 * (OFstatic_cast(int, sizeof (STD_NAMESPACE ptrdiff_t))
+                         - OFstatic_cast(int, sizeof (this))) + 1];
+    (void)size_check;
+    oss << getpid () << "-" << OFreinterpret_cast(STD_NAMESPACE ptrdiff_t, this);
+    STD_NAMESPACE string name (oss.str ());
+
+    sem = sem_open (name.c_str (), O_CREAT, S_IRWXU | S_IRWXG, limited_max);
+    ret = sem == SEM_FAILED;
+    if (ret != 0)
+        DCMTK_LOG4CPLUS_THROW_RTE ("Semaphore::Semaphore");
+
+    try
+    {
+        // Unlink the semaphore early to simulate anonymous semaphore.
+        ret = sem_unlink (name.c_str ());
+        if (ret != 0)
+            DCMTK_LOG4CPLUS_THROW_RTE ("Semaphore::Semaphore");
+    }
+    catch (STD_NAMESPACE runtime_error const &)
+    {
+        ret = sem_close (sem);
+        if (ret != 0)
+            DCMTK_LOG4CPLUS_THROW_RTE ("Semaphore::~Semaphore");
+
+        throw;
+    }
+
+#else
+    ret = sem_init (&sem, 0, limited_max);
+    if (ret != 0)
+        DCMTK_LOG4CPLUS_THROW_RTE ("Semaphore::Semaphore");
+
+#endif
+
+    try
+    {
+        for (unsigned i = limited_initial; i < limited_max; ++i)
+            lock ();
+    }
+    catch (STD_NAMESPACE runtime_error const &)
+    {
+#if defined (DCMTK_LOG4CPLUS_USE_NAMED_POSIX_SEMAPHORE)
+        ret = sem_close (sem);
+#else
+        ret = sem_destroy (&sem);
+#endif
+        if (ret != 0)
+            DCMTK_LOG4CPLUS_THROW_RTE ("Semaphore::~Semaphore");
+
+        throw;
+    }
+}
+
+
+inline
+Semaphore::~Semaphore ()
+{
+    try
+    {
+        int ret = 0;
+#if defined (DCMTK_LOG4CPLUS_USE_NAMED_POSIX_SEMAPHORE)
+        ret = sem_close (sem);
+#else
+        ret = sem_destroy (&sem);
+#endif
+        if (ret != 0)
+            DCMTK_LOG4CPLUS_THROW_RTE ("Semaphore::~Semaphore");
+    }
+    catch (...)
+    { }
+}
+
+
+inline
+void
+Semaphore::unlock () const
+{
+#if defined (DCMTK_LOG4CPLUS_USE_NAMED_POSIX_SEMAPHORE)
+    int ret = sem_post (sem);
+#else
+    int ret = sem_post (&sem);
+#endif
+    if (ret != 0)
+        DCMTK_LOG4CPLUS_THROW_RTE ("Semaphore::unlock");
+}
+
+
+inline
+void
+Semaphore::lock () const
+{
+#if defined (DCMTK_LOG4CPLUS_USE_NAMED_POSIX_SEMAPHORE)
+    int ret = sem_wait (sem);
+#else
+    int ret = sem_wait (&sem);
+#endif
+    if (ret != 0)
+        DCMTK_LOG4CPLUS_THROW_RTE ("Semaphore::lock");
+}
+
+
+//
+//
+//
+
+
+inline
+FairMutex::FairMutex ()
+    : sem (1, 1)
+{ }
+
+
+inline
+FairMutex::~FairMutex ()
+{ }
+
+
+inline
+void
+FairMutex::lock () const
+{
+    sem.lock ();
+}
+
+
+inline
+void
+FairMutex::unlock () const
+{
+    sem.unlock ();
+}
+
+
+//
+//
+//
+
+inline
+ManualResetEvent::ManualResetEvent (bool sig)
+    : cv ()
+    , mtx (log4cplus::thread::Mutex::DEFAULT)
+    , sigcount (0)
+    , signaled (sig)
+{
+    int ret = pthread_cond_init (&cv, 0);
+    if (ret != 0)
+        DCMTK_LOG4CPLUS_THROW_RTE ("ManualResetEvent::ManualResetEvent");
+}
+
+
+inline
+ManualResetEvent::~ManualResetEvent ()
+{
+    try
+    {
+        int ret = pthread_cond_destroy (&cv);
+        if (ret != 0)
+            DCMTK_LOG4CPLUS_THROW_RTE ("ManualResetEvent::~ManualResetEvent");
+    }
+    catch (...)
+    { }
+}
+
+
+inline
+void
+ManualResetEvent::signal () const
+{
+    MutexGuard mguard (mtx);
+
+    signaled = true;
+    sigcount += 1;
+    int ret = pthread_cond_broadcast (&cv);
+    if (ret != 0)
+        DCMTK_LOG4CPLUS_THROW_RTE ("ManualResetEVent::signal");
+
+}
+
+
+inline
+void
+ManualResetEvent::wait () const
+{
+    MutexGuard mguard (mtx);
+
+    if (! signaled)
+    {
+        unsigned prev_count = sigcount;
+        do
+        {
+            int ret = pthread_cond_wait (&cv, &mtx.mtx);
+            if (ret != 0)
+            {
+                mguard.unlock ();
+                mguard.detach ();
+                DCMTK_LOG4CPLUS_THROW_RTE ("ManualResetEvent::wait");
+            }
+        }
+        while (prev_count == sigcount);
+    }
+}
+
+
+inline
+bool
+ManualResetEvent::timed_wait (unsigned long msec) const
+{
+    MutexGuard mguard (mtx);
+
+    if (! signaled)
+    {
+        helpers::Time const wakeup_time (helpers::Time::gettimeofday ()
+            + helpers::Time (msec / 1000, (msec % 1000) * 1000));
+        struct timespec const ts = {wakeup_time.sec (),
+            wakeup_time.usec () * 1000};
+        unsigned prev_count = sigcount;
+        do
+        {
+            int ret = pthread_cond_timedwait (&cv, &mtx.mtx, &ts);
+            switch (ret)
+            {
+            case 0:
+                break;
+
+            case ETIMEDOUT:
+                return false;
+
+            default:
+                mguard.unlock ();
+                mguard.detach ();
+                DCMTK_LOG4CPLUS_THROW_RTE ("ManualResetEvent::timed_wait");
+            }
+        }
+        while (prev_count == sigcount);
+    }
+
+    return true;
+}
+
+
+inline
+void
+ManualResetEvent::reset () const
+{
+    MutexGuard mguard (mtx);
+
+    signaled = false;
+}
+
+
+//
+//
+//
+
+#if defined (DCMTK_LOG4CPLUS_POOR_MANS_SHAREDMUTEX)
+#include "dcmtk/ofstd/thread/impl/syncpmsm.h"
+
+#else
+inline
+SharedMutex::SharedMutex ()
+    : rwl()
+{
+    int ret = pthread_rwlock_init (&rwl, 0);
+    if (ret != 0)
+        DCMTK_LOG4CPLUS_THROW_RTE ("SharedMutex::SharedMutex");
+}
+
+
+inline
+SharedMutex::~SharedMutex ()
+{
+    try
+    {
+        int ret = pthread_rwlock_destroy (&rwl);
+        if (ret != 0)
+            DCMTK_LOG4CPLUS_THROW_RTE ("SharedMutex::~SharedMutex");
+    }
+    catch (...)
+    { }
+}
+
+
+inline
+void
+SharedMutex::rdlock () const
+{
+    int ret;
+
+    do
+    {
+        ret = pthread_rwlock_rdlock (&rwl);
+        switch (ret)
+        {
+        case EAGAIN:
+            // The read lock could not be acquired because the maximum
+            // number of read locks for rwlock has been exceeded.
+
+            log4cplus::thread::yield ();
+            // Fall through.
+
+        case 0:
+            break;
+
+        default:
+            DCMTK_LOG4CPLUS_THROW_RTE ("SharedMutex::rdlock");
+
+        }
+    }
+    while (ret != 0);
+}
+
+
+inline
+void
+SharedMutex::rdunlock () const
+{
+    unlock ();
+}
+
+
+inline
+void
+SharedMutex::wrlock () const
+{
+    int ret = pthread_rwlock_wrlock (&rwl);
+    if (ret != 0)
+        DCMTK_LOG4CPLUS_THROW_RTE ("SharedMutex::wrlock");
+}
+
+
+inline
+void
+SharedMutex::wrunlock () const
+{
+    unlock ();
+}
+
+
+inline
+void
+SharedMutex::unlock () const
+{
+    int ret = pthread_rwlock_unlock (&rwl);
+    if (ret != 0)
+        DCMTK_LOG4CPLUS_THROW_RTE ("SharedMutex::unlock");
+
+}
+
+
+#endif
+
+
+} } } // namespace log4cplus { namespace thread { namespace impl {
+} // end namespace dcmtk
diff --git a/oflog/include/dcmtk/oflog/thread/impl/syncwin.h b/oflog/include/dcmtk/oflog/thread/impl/syncwin.h
new file mode 100644
index 0000000..1bed3bb
--- /dev/null
+++ b/oflog/include/dcmtk/oflog/thread/impl/syncwin.h
@@ -0,0 +1,330 @@
+// -*- C++ -*-
+//  Copyright (C) 2009-2010, Vaclav Haisman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+//! @file
+//! This file contains implementations of synchronization
+//! primitives using the Win32 API. It does not contain any include
+//! guards because it is only a fragment to be included by
+//! syncprims.h.
+
+#include <stdexcept>
+
+
+namespace dcmtk {
+namespace log4cplus { namespace thread { namespace impl {
+
+
+//
+//
+//
+
+inline
+bool
+InitializeCriticalSection_wrapInternal (LPCRITICAL_SECTION cs)
+{
+#if defined (_MSC_VER)
+    __try
+    {
+#endif
+
+    InitializeCriticalSection (cs);
+
+#if defined (_MSC_VER)
+    }
+    __except (GetExceptionCode() == STATUS_NO_MEMORY
+        ? EXCEPTION_EXECUTE_HANDLER : EXCEPTION_CONTINUE_SEARCH)
+    {
+        return false;
+    }
+#endif
+
+    return true;
+}
+
+
+inline
+void
+InitializeCriticalSection_wrap (LPCRITICAL_SECTION cs)
+{
+    if (! InitializeCriticalSection_wrapInternal (cs))
+        throw STD_NAMESPACE runtime_error (
+            "InitializeCriticalSection: STATUS_NO_MEMORY");
+}
+
+
+inline
+Mutex::Mutex (log4cplus::thread::Mutex::Type)
+{
+    InitializeCriticalSection_wrap (&cs);
+}
+
+
+inline
+Mutex::~Mutex ()
+{
+    DeleteCriticalSection (&cs);
+}
+
+
+inline
+void
+Mutex::lock () const
+{
+    EnterCriticalSection (&cs);
+}
+
+
+inline
+void
+Mutex::unlock () const
+{
+    LeaveCriticalSection (&cs);
+}
+
+
+//
+//
+//
+
+inline
+Semaphore::Semaphore (unsigned max, unsigned initial)
+{
+    sem = CreateSemaphore (0, initial, max, 0);
+    if (! sem)
+        DCMTK_LOG4CPLUS_THROW_RTE ("Semaphore::Semaphore");
+}
+
+
+inline
+Semaphore::~Semaphore ()
+{
+    try
+    {
+        if (! CloseHandle (sem))
+            DCMTK_LOG4CPLUS_THROW_RTE ("Semaphore::~Semaphore");
+    }
+    catch (...)
+    { }
+}
+
+
+inline
+void
+Semaphore::unlock () const
+{
+    DWORD ret = ReleaseSemaphore (sem, 1, 0);
+    if (! ret)
+         DCMTK_LOG4CPLUS_THROW_RTE ("Semaphore::unlock");
+}
+
+
+inline
+void
+Semaphore::lock () const
+{
+    DWORD ret = WaitForSingleObject (sem, INFINITE);
+    if (ret != WAIT_OBJECT_0)
+        DCMTK_LOG4CPLUS_THROW_RTE ("Semaphore::lock");
+}
+
+
+//
+//
+//
+
+
+inline
+FairMutex::FairMutex ()
+{
+    mtx = CreateMutex (0, false, 0);
+    if (! mtx)
+        DCMTK_LOG4CPLUS_THROW_RTE ("FairMutex::FairMutex");
+}
+
+
+inline
+FairMutex::~FairMutex ()
+{
+    try
+    {
+        if (! CloseHandle (mtx))
+            DCMTK_LOG4CPLUS_THROW_RTE ("FairMutex::~FairMutex");
+    }
+    catch (...)
+    { }
+}
+
+
+inline
+void
+FairMutex::lock () const
+{
+    DWORD ret = WaitForSingleObject (mtx, INFINITE);
+    if (ret != WAIT_OBJECT_0)
+        DCMTK_LOG4CPLUS_THROW_RTE ("FairMutex::lock");
+}
+
+
+inline
+void
+FairMutex::unlock () const
+{
+    if (! ReleaseMutex (mtx))
+        DCMTK_LOG4CPLUS_THROW_RTE ("FairMutex::unlock");
+}
+
+
+//
+//
+//
+
+inline
+ManualResetEvent::ManualResetEvent (bool sig)
+{
+    ev = CreateEvent (0, true, sig, 0);
+    if (! ev)
+        DCMTK_LOG4CPLUS_THROW_RTE ("ManualResetEvent::ManualResetEvent");
+}
+
+
+inline
+ManualResetEvent::~ManualResetEvent ()
+{
+    try
+    {
+        if (! CloseHandle (ev))
+            DCMTK_LOG4CPLUS_THROW_RTE ("ManualResetEvent::~ManualResetEvent");
+    }
+    catch (...)
+    { }
+}
+
+
+inline
+void
+ManualResetEvent::signal () const
+{
+    if (! SetEvent (ev))
+        DCMTK_LOG4CPLUS_THROW_RTE ("ManualResetEVent::signal");
+}
+
+
+inline
+void
+ManualResetEvent::wait () const
+{
+    DWORD ret = WaitForSingleObject (ev, INFINITE);
+    if (ret != WAIT_OBJECT_0)
+        DCMTK_LOG4CPLUS_THROW_RTE ("ManualResetEvent::wait");
+}
+
+
+inline
+bool
+ManualResetEvent::timed_wait (unsigned long msec) const
+{
+    DWORD ret = WaitForSingleObject (ev, OFstatic_cast(DWORD, msec));
+    switch(ret)
+    {
+    case WAIT_OBJECT_0:
+        return true;
+
+    case WAIT_TIMEOUT:
+        return false;
+
+    default:
+        DCMTK_LOG4CPLUS_THROW_RTE ("ManualResetEvent::timed_wait");
+        // Silence warnings about not returning any value from function
+        // returning bool.
+        return false;
+    }
+}
+
+
+inline
+void
+ManualResetEvent::reset () const
+{
+    if (! ResetEvent (ev))
+        DCMTK_LOG4CPLUS_THROW_RTE ("ManualResetEvent::reset");
+}
+
+
+//
+//
+//
+
+#if defined (DCMTK_LOG4CPLUS_POOR_MANS_SHAREDMUTEX)
+#include "dcmtk/oflog/thread/impl/syncpmsm.h"
+
+#else
+inline
+SharedMutex::SharedMutex ()
+{
+    InitializeSRWLock (&srwl);
+}
+
+
+inline
+SharedMutex::~SharedMutex ()
+{ }
+
+
+inline
+void
+SharedMutex::rdlock () const
+{
+    AcquireSRWLockShared (&srwl);
+}
+
+
+inline
+void
+SharedMutex::rdunlock () const
+{
+    ReleaseSRWLockShared (&srwl);
+}
+
+
+inline
+void
+SharedMutex::wrlock () const
+{
+    AcquireSRWLockExclusive (&srwl);
+}
+
+
+inline
+void
+SharedMutex::wrunlock () const
+{
+    ReleaseSRWLockExclusive (&srwl);
+}
+
+
+#endif
+
+
+} } } // namespace log4cplus { namespace thread { namespace impl {
+} // end namespace dcmtk
diff --git a/oflog/include/dcmtk/oflog/thread/impl/thredimp.h b/oflog/include/dcmtk/oflog/thread/impl/thredimp.h
new file mode 100644
index 0000000..4b1d801
--- /dev/null
+++ b/oflog/include/dcmtk/oflog/thread/impl/thredimp.h
@@ -0,0 +1,162 @@
+// -*- C++ -*-
+// Module:  Log4CPLUS
+// File:    threads.h
+// Created: 6/2001
+// Author:  Tad E. Smith
+//
+//
+// Copyright 2001-2010 Tad E. Smith
+//
+// Licensed under the Apache License, Version 2.0 (the "License");
+// you may not use this file except in compliance with the License.
+// You may obtain a copy of the License at
+//
+//     http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software
+// distributed under the License is distributed on an "AS IS" BASIS,
+// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+// See the License for the specific language governing permissions and
+// limitations under the License.
+
+/** @file */
+
+#ifndef DCMTK_LOG4CPLUS_IMPL_THREADS_IMPL_HEADER_
+#define DCMTK_LOG4CPLUS_IMPL_THREADS_IMPL_HEADER_
+
+#include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#if defined (_WIN32)
+#include "dcmtk/oflog/config/windowsh.h"
+#endif
+#include "dcmtk/oflog/tstring.h"
+#include "dcmtk/oflog/helpers/pointer.h"
+#include "dcmtk/oflog/thread/threads.h"
+
+#if ! defined (DCMTK_INSIDE_LOG4CPLUS)
+#  error "This header must not be be used outside log4cplus' implementation files."
+#endif
+
+
+namespace dcmtk {
+namespace log4cplus { namespace thread { namespace impl {
+
+
+#if defined (DCMTK_LOG4CPLUS_USE_PTHREADS)
+
+typedef pthread_t os_handle_type;
+typedef pthread_t os_id_type;
+
+
+inline
+pthread_t
+getCurrentThreadId ()
+{
+    return pthread_self ();
+}
+
+
+#elif defined (DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
+
+typedef HANDLE os_handle_type;
+typedef DWORD os_id_type;
+
+
+inline
+DWORD
+getCurrentThreadId ()
+{
+    return GetCurrentThreadId ();
+}
+
+
+#elif defined (DCMTK_LOG4CPLUS_SINGLE_THREADED)
+
+typedef void * os_handle_type;
+typedef int os_id_type;
+
+
+inline
+int
+getCurrentThreadId ()
+{
+    return 1;
+}
+
+
+#endif
+
+
+#ifndef DCMTK_LOG4CPLUS_SINGLE_THREADED
+
+
+struct ThreadStart
+{
+#  ifdef DCMTK_LOG4CPLUS_USE_PTHREADS
+static void* threadStartFuncWorker(void *);
+#  elif defined(DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
+static unsigned threadStartFuncWorker(void *);
+#  endif
+};
+
+
+/**
+ * There are many cross-platform C++ Threading libraries.  The goal of
+ * this class is not to replace (or match in functionality) those
+ * libraries.  The goal of this class is to provide a simple Threading
+ * class with basic functionality.
+ */
+class Thread
+    : public ThreadImplBase
+{
+public:
+    Thread();
+    bool isRunning() const;
+    os_id_type getThreadId() const;
+    os_handle_type getThreadHandle () const;
+    void start();
+    void join ();
+
+protected:
+    // Force objects to be constructed on the heap
+    virtual ~Thread();
+    virtual void run() = 0;
+
+private:
+    // Friends.
+    friend struct ThreadStart;
+
+    enum Flags
+    {
+        fRUNNING  = 0x01,
+        fJOINED   = 0x02
+    };
+
+    unsigned flags;
+
+    os_handle_type handle;
+
+#  if defined(DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
+    unsigned thread_id;
+#  endif
+
+    // Disallow copying of instances of this class.
+    Thread(const Thread&);
+    Thread& operator=(const Thread&);
+};
+
+typedef helpers::SharedObjectPtr<Thread> ThreadPtr;
+
+
+#endif // DCMTK_LOG4CPLUS_SINGLE_THREADED
+
+
+} } } // namespace log4cplus { namespace thread { namespace impl {
+} // end namespace dcmtk
+
+
+#endif // DCMTK_LOG4CPLUS_IMPL_THREADS_IMPL_HEADER_
diff --git a/oflog/include/dcmtk/oflog/thread/impl/tls.h b/oflog/include/dcmtk/oflog/thread/impl/tls.h
new file mode 100644
index 0000000..ae30f33
--- /dev/null
+++ b/oflog/include/dcmtk/oflog/thread/impl/tls.h
@@ -0,0 +1,182 @@
+// -*- C++ -*-
+//  Copyright (C) 2010, Vaclav Haisman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#ifndef DCMTK_LOG4CPLUS_THREAD_IMPL_TLS_H
+#define DCMTK_LOG4CPLUS_THREAD_IMPL_TLS_H
+
+#include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#include <new>
+#include <cassert>
+
+#if ! defined (DCMTK_INSIDE_LOG4CPLUS)
+#  error "This header must not be be used outside log4cplus' implementation files."
+#endif
+
+#ifdef DCMTK_LOG4CPLUS_USE_PTHREADS
+#  include <pthread.h>
+
+#elif defined (DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
+#  include "dcmtk/oflog/config/windowsh.h"
+
+#elif defined (DCMTK_LOG4CPLUS_SINGLE_THREADED)
+#  include "dcmtk/ofstd/ofvector.h"
+
+#endif
+
+
+namespace dcmtk {
+namespace log4cplus { namespace thread { namespace impl {
+
+
+typedef void * tls_value_type;
+typedef void (* tls_init_cleanup_func_type)(void *);
+
+#ifdef DCMTK_LOG4CPLUS_USE_PTHREADS
+typedef pthread_key_t * tls_key_type;
+
+#elif defined (DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
+typedef DWORD tls_key_type;
+
+#elif defined (DCMTK_LOG4CPLUS_SINGLE_THREADED)
+typedef size_t tls_key_type;
+
+#endif
+
+
+inline tls_key_type tls_init (tls_init_cleanup_func_type);
+inline tls_value_type tls_get_value (tls_key_type);
+inline void tls_set_value (tls_key_type, tls_value_type);
+inline void tls_cleanup (tls_key_type);
+
+
+#if defined (DCMTK_LOG4CPLUS_USE_PTHREADS)
+tls_key_type
+tls_init (tls_init_cleanup_func_type cleanupfunc)
+{
+    pthread_key_t * key = new pthread_key_t;
+    pthread_key_create (key, cleanupfunc);
+    return key;
+}
+
+
+tls_value_type
+tls_get_value (tls_key_type key)
+{
+    return pthread_getspecific (*key);
+}
+
+
+void
+tls_set_value (tls_key_type key, tls_value_type value)
+{
+    pthread_setspecific(*key, value);
+}
+
+
+void
+tls_cleanup (tls_key_type key)
+{
+    pthread_key_delete (*key);
+    delete key;
+}
+
+
+#elif defined (DCMTK_LOG4CPLUS_USE_WIN32_THREADS)
+tls_key_type
+tls_init (tls_init_cleanup_func_type)
+{
+    return TlsAlloc ();
+}
+
+
+tls_value_type tls_get_value (tls_key_type k)
+{
+    return TlsGetValue (k);
+}
+
+
+void
+tls_set_value (tls_key_type k, tls_value_type value)
+{
+    TlsSetValue (k, value);
+}
+
+
+void
+tls_cleanup (tls_key_type k)
+{
+    TlsFree (k);
+}
+
+
+#elif defined (DCMTK_LOG4CPLUS_SINGLE_THREADED)
+extern OFVector<tls_value_type> * tls_single_threaded_values;
+
+
+tls_key_type
+tls_init (tls_init_cleanup_func_type)
+{
+    if (! tls_single_threaded_values)
+        tls_single_threaded_values = new OFVector<tls_value_type>;
+    tls_key_type key = tls_single_threaded_values->size ();
+    tls_single_threaded_values->resize (key + 1);
+    return key;
+}
+
+
+tls_value_type
+tls_get_value (tls_key_type k)
+{
+    assert (k < tls_single_threaded_values->size ());
+    return (*tls_single_threaded_values)[k];
+}
+
+
+void
+tls_set_value (tls_key_type k, tls_value_type val)
+{
+    assert (k < tls_single_threaded_values->size ());
+    (*tls_single_threaded_values)[k] = val;
+}
+
+
+void
+tls_cleanup (tls_key_type k)
+{
+    assert (k < tls_single_threaded_values->size ());
+    (*tls_single_threaded_values)[k] = 0;
+}
+
+#endif
+
+
+} } } // namespace log4cplus { namespace thread { namespace impl {
+} // end namespace dcmtk
+
+#endif // DCMTK_LOG4CPLUS_THREAD_IMPL_TLS_H
